<?php
/**
 * @file
 * Contains Attribute for miniOrange Login with NTLM Module.
 */

 /**
 * Showing Settings form.
 */
namespace Drupal\ldap_auth\Form;

use Drupal\Core\Form\FormBase;
use Drupal\ldap_auth\MiniorangeLDAPSupport;
use Drupal\ldap_auth\Utilities;

class AttributeMapping extends FormBase {
  public function getFormId() {
    return 'miniorange_ldap_attrmapping';
  }
 public function buildForm(array $form, \Drupal\Core\Form\FormStateInterface $form_state)
 {
  $attachments['#attached']['library'][] = 'ldap_auth/ldap_auth.admin';
  $form['markup_library'] = array(
      '#attached' => array(
          'library' => array(
              "ldap_auth/ldap_auth.admin",
              "ldap_auth/ldap_auth.testconfig",
          )
      ),
  );
  global $base_url;
  \Drupal::configFactory()->getEditable('ldap_auth.settings')->set('miniorange_ldap_disabled', FALSE)->save();

  $form['#prefix'] = '<div class="ui_text">';
  $form['#suffix'] = '</div>';
  Utilities::AddSupportButton( $form, $form_state);

    $form['miniorange_ldap_div_1'] = array(
      '#prefix' => "<div class='subdiv_ui'>",
        '#suffix' => "</div>",
      '#markup' => "
        <div style='background-color: rgb(241,241,241) ; padding: 20px'>
            <div style='background-color: white; padding: 10px ;margin-left: 20px; width: 70%' id='enable_ldap'>
            <h2>Attribute Mapping <i>(Available in the Premium Version of the Plugin)</i></h2><br>
            <p>Enter the LDAP attribute names for Email, Phone, First Name and Last Name attributes</p>
            </div>
      ",
    );
    

    $form['miniorange_ldap_email_attribute'] = array(
      '#type' => 'textfield',
      '#prefix' => "<div class='subdiv_ui'>",
        '#suffix' => "</div>",
      '#title' => t('Email Attribute:'),
      '#disabled' => true,
      '#id' => 'mo_ldap_email_attr',
      '#default_value' => \Drupal::config('ldap_auth.settings')->get('miniorange_ldap_email_attribute'),
      '#attributes' => array('placeholder' => 'Enter Username Attribute'),
  );
  $form['miniorange_ldap_phone_attribute'] = array(
      '#type' => 'textfield',
      '#title' => t('Phone :'),
      '#prefix' => "<div class='subdiv_ui'>",
      '#suffix' => "</div>",
      '#disabled' => true,
      '#id' => 'mo_ldap_email_attr',
      '#default_value' => \Drupal::config('ldap_auth.settings')->get('miniorange_ldap_phone_attribute'),
      '#attributes' => array('placeholder' => 'Enter phone Attribute'),   
  );
  $form['miniorange_ldap_first_name_attribute'] = array(
      '#type' => 'textfield',
      '#title' => t('First Name:'),
      '#prefix' => "<div class='subdiv_ui'>",
      '#suffix' => "</div>",
      '#id' => 'mo_ldap_email_attr',
      '#disabled' => true,
      '#default_value' => \Drupal::config('ldap_auth.settings')->get('miniorange_ldap_first_name_attribute'),
      '#attributes' => array('placeholder' => 'Enter first name Attribute'),
  );
  $form['miniorange_ldap_last_name_attribute'] = array(
      '#type' => 'textfield',
      '#prefix' => "<div class='subdiv_ui'>",
      '#suffix' => "</div><br>",
      '#title' => t('Last Name:'),
      '#id' => 'mo_ldap_email_attr',
          '#disabled' => true,
      '#default_value' => \Drupal::config('ldap_auth.settings')->get('miniorange_ldap_last_name_attribute'),
      '#attributes' => array('placeholder' => 'Enter last name Attribute'),
  );
  $form['miniorange_ldap_contact_ldap_server']= array(
      '#type' => 'submit',
      '#prefix' => "<div class='subdiv_ui'>",
        '#suffix' => "</div>",
      '#id' => 'button_config',
      '#disabled' => true,
      '#value' => t('Save Configurations'),
      '#submit' => array('::test_attr_connection'),
      '#attributes' => array('style' => 'border-radius:4px;background: #337ab7;color: #ffffff;text-shadow: 0 -1px 1px #337ab7, 1px 0 1px #337ab7, 0 1px 1px #337ab7, -1px 0 1px #337ab7;
              box-shadow: 0 2px 0 #006799;border-color: #337ab7 #337ab7 #337ab7; width: 30%;display:block;margin-right:auto;'),
  );


  $form['mini_br_1'] = array(
    '#prefix' => "<div class='subdiv_ui'>",
    '#suffix' => "</div>",
    '#markup'=>"<br><br><br>",
);

// Role Mapping
$form['miniorange_ldap_enable_ldap_role_mapping_markup'] = array(
  '#prefix' => "<div class='subdiv_ui'>",
  '#suffix' => "</div>",
    '#markup' => "<div><h1><b>LDAP Groups to Drupal User Role Mapping</b></h1><hr></div><br>",
);
$form['miniorange_ldap_enable_rolemapping'] = array(
    '#type' => 'checkbox',
    '#id' => 'check',
    '#prefix' => "<div class='subdiv_ui'>",
    '#suffix' => "</div>",
    '#disabled' => true,
    '#description' => 'Enabling Role Mapping will automatically map Users from LDAP Groups to below selected Drupal Role. Role mapping will not be applicable for primary admin of Drupal.',
    '#title' => t('Enable Role Mapping'),
    '#default_value' =>\Drupal::config('ldap_auth.settings')->get('miniorange_ldap_enable_rolemapping'),
);
$form['miniorange_ldap_disable_role_update'] = array(
    '#type' => 'checkbox',
    '#prefix' => "<div class='subdiv_ui'>",
    '#suffix' => "</div>",
    '#disabled' => true,
    '#title' => t('Check this option if you do not want to update user role if roles not mapped'),
    '#default_value' => \Drupal::config('ldap_auth.settings')->get('miniorange_ldap_disable_role_update'),
);
$form['miniorange_ldap_enable_ntlm_role_mapping'] = array(
    '#type' => 'checkbox',
    '#prefix' => "<div class='subdiv_ui'>",
    '#suffix' => "</div>",
    '#disabled' => true,
    '#title' => t('Enable Role Mapping for NTLM Users '),
    '#description' => 'Likewise Role Mapping, enabling this option automatically map NTLM user roles from LDAP Groups to below selected Drupal Role..',
    '#default_value' => \Drupal::config('ldap_auth.settings')->get('miniorange_ldap_enable_ntlm_role_mapping'),
    '#suffix' => '<br>',
);

$mrole = user_role_names(TRUE);
$def_role = \Drupal::configFactory()->getEditable('ldap_auth.settings')->get('miniorange_ldap_def_role');

$form['miniorange_ldap_default_mapping'] = array(
    '#type' => 'select',
    '#prefix' => "<div class='subdiv_ui'>",
    '#suffix' => "</div>",
    '#title' => t('Select default group for the users'),
    '#disabled' => true,
    '#options' => array_values($mrole),
    '#default_value' => is_array($def_role) ? array_search (\Drupal::config('ldap_auth.settings')->get('miniorange_ldap_default_role'), $def_role) : '',
    '#attributes' => array('style' => 'width:700px'),
);
$form['miniorange_ldap_memberOf'] = array(
    '#type' => 'textfield',
    '#prefix' => "<div class='subdiv_ui'>",
    '#suffix' => "</td></div>",
    '#disabled' => true,
    '#title' => t('LDAP Group Name'),
    '#attributes' => array('style' => 'width:700px','placeholder' => 'memberOf'),
    '#default_value' => \Drupal::config('ldap_auth.settings')->get('miniorange_ldap_memberOf'),
);
foreach($mrole as $roles) {
    $rolelabel = str_replace(' ','',$roles);
    $form['miniorange_ldap_role_' . $rolelabel] = array(
        '#type' => 'textfield',
        '#title' => t($roles),
        '#prefix' => "<div class='subdiv_ui'>",
        '#suffix' => "</div>",
        '#disabled' => true,
        '#default_value' => \Drupal::config('ldap_auth.settings')->get('miniorange_ldap_role_' . $rolelabel),
        '#attributes' => array('style' => 'width:700px','placeholder' => 'Semi-colon(;) separated Group/Role value for ' . $roles),
        '#required' => FALSE,
    );
}

  $form['miniorange_ldap_contact_server']= array(
    '#markup' => "<div class ='subdiv_ui'>
    <div id='base_Url' name='base_Url' data='". $base_url."'></div>
   <a id='ping_server' class='btn btn-primary btn-sm' disabled style='padding:6px 12px;'>Save Configuration</a>
    </div>",
  );
        return $form;
  }
  public function submitForm(array &$form, \Drupal\Core\Form\FormStateInterface $form_state)
  {

  }
  function saved_support(array &$form, \Drupal\Core\Form\FormStateInterface $form_state)
   {
        $email = $form['miniorange_ldap_email_address']['#value'];
        $phone = $form['miniorange_ldap_phone_number']['#value'];
        $query = $form['miniorange_ldap_support_query']['#value'];
        if(!empty($email))
        {
            $support = new MiniorangeLDAPSupport($email, $phone, $query);
            $support_response = $support->sendSupportQuery();
            if ($support_response) {
                \Drupal::messenger()->addMessage(t('Support query successfully sent'));
            } else {
                \Drupal::messenger()->addMessage(t('Error sending support query'), 'error');
            }
        }
        else{
            print_r('Email can not be empty for sending a support quesry. Please fill the email and try again.');exit;
        }
   }
}